/* Michael Beal
 * CSE142, Spring 1999
 * Homework 4
 * Traffic animation

  STARTER PROGRAM

 * Section BC
 *
 */


#include "gp142.h"
#include <stdio.h>
#include <math.h>

#include <time.h>
	/* 
	* <time.h> is included so the current time can be accessed
	* to initialize the random number generator.  If you don't
	* use random numbers (and you don't have to) you can either
	* ignore this #include or delete it.
	*/

/* Logical constants */
#define TRUE    		1
#define FALSE   		0

/* 
 * For many of the GP142 functions, a line width of
 * zero means to fill the shape being drawn.  The
 * constant FILL is used in function calls when a solid
 * shape is desired.
 */
#define FILL 0


/*
 * Symbolic constants.  Change as needed.
 */

/* Menu buttons: */

/* Top-left coordinates of button palette */
#define MENU_TOP		(GP142_YMAX - 5)
#define MENU_LEFT		(-GP142_XMAX + 5)

/* Height and width of buttons in pixels */
#define BUTTON_HEIGHT  	25
#define BUTTON_WIDTH 	75

/* Number of buttons */
#define NUM_BUTTONS 	6


/* Possible locations of mouse clicks: */

/*   Mouse click in some button */
#define BUTTON_CLICK 1

/*   Mouse click elsewhere */
#define OTHER_CLICK 0


/* Coordinates of objects in the drawing */

/* y-coordinate of the top of the ground in the landscape */
#define HORIZON (- 2 * (GP142_YMAX / 10))

/* Vertical center and width of highway */
#define HIGHWAY_CENTER ((-GP142_YMAX + HORIZON) / 3)
#define HIGHWAY_CENTER_2 ((-GP142_YMAX + HORIZON) / 3)-75 
#define HIGHWAY_WIDTH  10


/* Maximum number of vehicles that can appear in the animation */
#define MAX_VEHICLES	35

/* Height and width of a single car */
#define CAR_HEIGHT 24
#define CAR_WIDTH  40

/* The man's place on the screen */
#define MAN_DIS 100

/* Radius of the man's head */
#define HEAD 4

/* Vehicles information: 0-x, 1-y, 2-direction, 4-color, 3-speed, 5-moving */
#define VEHICLES_INFO 7

/* Information about vehicles in the animation:						*/

#define X_POS 0		/* current position of the car					*/
#define Y_POS 1
#define DIR   2		/* current direction: +1=right, -1=left			*/
#define SPEED 3     /* speed in pixels per tick when traffic moving	*/
#define COLOR 4		/* color of the car								*/
#define MOVE  5		/* = "traffic is currently moving"				*/


/*****************************************************************************

     FUNCTION PROTOTYPES

*****************************************************************************/

/* Initialize random number generator.  [Ignore or		*/
/* remove if your program doesn't use random numbers.]	*/
void initialize_random_numbers();

/* Draw the background, including the sun at coordinates sun_x and sun_y */
void draw_landscape(int sun_x, int sun_y);

/* Draw the buttons */
void draw_buttons();

/* Return kind of mouse click (in a button, etc.) */
int  classify_mouse_click(int mouse_x, int mouse_y);

/* Process button click at location x, y.  Update car speed,  */
/* direction, color, and whether traffic is moving as needed. */
void handle_button(int x, int y, int cars [MAX_VEHICLES][VEHICLES_INFO],
				   int num_of_cars);

/* Update sun coordinates sun_x, sun_y for one tick */
void move_sun(int *sun_x, int *sun_y);

/* Update all vehicle x, y coordinates, given current x, y */
/* location, direction (+1 or -1), and speed in pixels per tick. */
void move_traffic(int cars[MAX_VEHICLES][VEHICLES_INFO], int num_of_cars);

/* Draw all vehicles given their current x, y coordinates and color */
void draw_traffic(int cars [MAX_VEHICLES][VEHICLES_INFO], int num_of_cars);

/* Draw a single car of the given color with horizontal */
/* center x and bottom y*/
void draw_car(int x, int y, int color, int j, int dir);

/* Display error message if internal error is detected. */
void something_is_wrong (void);

/* Draw man by the road */
void man (int cars[MAX_VEHICLES][VEHICLES_INFO], int num_of_cars);

/* Draw bird */
void bird (int*bird_x, int*bird_y,int cars [MAX_VEHICLES][VEHICLES_INFO]);

/*****************************************************************************

     MAIN

*****************************************************************************/

/*
 * Main program contents:
 *   - Major program variables that persist throughout execution
 *   - Event loop that processes GP142 events until the user quits,
 *     and updates variables and redraws the window as needed.
 */
int main(void)
{
	/* Event handling and buttons: */
	int  quit;				/* = "user has selected quit"				*/
	int  event;				/* the most recent GP142 event				*/
	char key_pressed;		/* last keyboard character from key event	*/
	int  mouse_x, mouse_y;	/* x and y coordinates of latest mouse event*/
	int  click_kind;		/* kind of mouse click (button, etc.)		*/

	/* Information about the sun: */
	int sun_x, sun_y;			/* screen x and y coordinates */

	/* 2D array to hold the data on each car */
	int cars [MAX_VEHICLES][VEHICLES_INFO];

	/* Car number */
	int j = 0;
	int num_of_cars = 1;

	/* set intial location of bird*/
	int bird_x = 250;
    int bird_y = 200;
	initialize_random_numbers();
	
	/* Initialize graphics package, clear the window,	*/
	/* turn logging off, and start animation.			*/
	GP142_open();
	GP142_logging(LOG_OFF);
	GP142_clear();
	GP142_animate(ANI_RUN);

	/* set initial location of the sun */
	sun_x = GP142_XMAX - 50;
	sun_y = GP142_YMAX - 35;




	while (j < MAX_VEHICLES)
	{
	/* set initial conditions for the car */
	
	if (j%2 == 0)
	{
	cars [j][X_POS] = -GP142_XMAX ;
	cars [j][Y_POS] = HIGHWAY_CENTER +5;
	cars [j][DIR]   = +1;
	}
	else
	{
	cars [j][X_POS] = GP142_XMAX ;
	cars [j][Y_POS] = HIGHWAY_CENTER -5;
	cars [j][DIR]   = -1;
	}
	cars [j][SPEED] = 5 + j;					
	cars [j][COLOR] = RED + j;				
	cars [j][MOVE]  = TRUE;
	cars [0][SPEED] = 30;			
	j++;
	}

	
	
	/* Draw initial landscape, buttons, and traffic */
	draw_landscape(sun_x,sun_y);
	draw_buttons( );	
	man (cars, num_of_cars);
	draw_traffic(cars, num_of_cars);
	bird(&bird_x, &bird_y, cars);
	/*
	 * Main event loop:
	 * ---- ----- -----
	 * Wait for the next user action, decode it, and call an
	 * appropriate function to handle it.  Repeat until the
	 * user selects quit.
	 */
	quit = FALSE;
	while (!quit) {
		
		/* get next event */
		event = GP142_await_event(&mouse_x, &mouse_y, &key_pressed);
	


		/* perform appropriate action depending on kind of event */
		switch (event) {
		case GP142_QUIT:
			/* Quit selected */
			quit = TRUE;
			break;
			
		case GP142_KBD:
			
			
            num_of_cars = num_of_cars + 1;


			break;
			
		case GP142_MOUSE:
			/* Mouse click.  Determine if in a menu button	*/
			/* or elsewhere and process accordingly.		*/
			click_kind = classify_mouse_click(mouse_x, mouse_y);
			if (click_kind == BUTTON_CLICK) {
				handle_button(mouse_x, mouse_y, cars, num_of_cars);
			} else {
				/* insert code here (and additional else-if statements) */
				/* to react to mouse clicks elsewhere on the screen */
			}
			break;
			
		case GP142_PERIODIC:
			/* Timer interval event.  Update everything	*/
			/* that needs to change as time advances.	*/
			move_sun(&sun_x, &sun_y);
			if (cars [0][MOVE])
				move_traffic(cars, num_of_cars);
			break;
			
		default:
			/* unknown event */
			break;
			
		}  /*end switch */
		
		/* Redraw everything */
		draw_landscape(sun_x, sun_y);
		draw_buttons();
		man (cars, num_of_cars);
		draw_traffic(cars, num_of_cars);
		bird(&bird_x, &bird_y, cars);
		

	}  /* end event loop */
	
	
	/* Termination: shut down graphics window and exit */
	GP142_close();
	return 0;
}  /*end main */


/*****************************************************************************

     BACKGROUND LANDSCAPE

*****************************************************************************/


/* Draw the background, including the sun at coordinates sun_x and sun_y */
void draw_landscape(int sun_x, int sun_y)
{
	int text_offset = -GP142_XMAX + 15;	/* horizontal offset of text */
	int text_size   = 12;				/* size of text font */

	/* Draw the sky */
	GP142_rectangleXY(ICE_BLUE, -GP142_XMAX, -GP142_YMAX,
		GP142_XMAX, GP142_YMAX, FILL);
	
	/* Draw the sun */
	GP142_circleXY(YELLOW, sun_x, sun_y , 20);
	
	/* Draw the ground, highway, and text legend */
	GP142_rectangleXY(BROWN, -GP142_XMAX, -GP142_YMAX,
		GP142_XMAX, HORIZON, FILL);
	GP142_rectangleXY(LT_GRAY, 
					-GP142_XMAX, HIGHWAY_CENTER - HIGHWAY_WIDTH,
					 GP142_XMAX, HIGHWAY_CENTER + HIGHWAY_WIDTH,
					 FILL);
	GP142_rectangleXY(LT_GRAY, 
					-GP142_XMAX, HIGHWAY_CENTER_2 - HIGHWAY_WIDTH,
					 GP142_XMAX, HIGHWAY_CENTER_2 + HIGHWAY_WIDTH,
					 FILL);
	GP142_printfXY (BLACK, text_offset, -GP142_YMAX+30, text_size,
		"Click a button to control the car.");
	GP142_lineXY (BLACK, -GP142_XMAX, HIGHWAY_CENTER,
			GP142_XMAX, HIGHWAY_CENTER, FILL);
    GP142_lineXY (BLACK, -GP142_XMAX, HIGHWAY_CENTER_2,
			GP142_XMAX, HIGHWAY_CENTER_2, FILL);

	/*Draw some mountains */
	GP142_triangleXY(MED_GRAY,
		-GP142_XMAX, HORIZON,
		GP142_XMAX, HORIZON,
		0, (4 * GP142_YMAX)/5 ,
		FILL);
	
	GP142_triangleXY(OLIVE,
		-( 5 * GP142_XMAX/4), HORIZON,
		(GP142_XMAX)/3  , HORIZON,
		-(3* GP142_XMAX)/4, (2 * GP142_YMAX)/3 ,
		FILL);
	
	GP142_triangleXY(FOREST_GREEN,
		-GP142_XMAX / 3 , HORIZON,
		GP142_XMAX, HORIZON,
		GP142_XMAX, (2 * GP142_YMAX)/3 ,
		FILL);
	
} 





/*end draw_landscape */



/*****************************************************************************

     BUTTONS AND MOUSE CLICKS

*****************************************************************************/


/* Draws the buttons */
void draw_buttons( )
{
	int i;
	int text_offset = MENU_LEFT+10;	/* offset of button text in button */
	int font_size = 12;				/* size of button text */
	
	/* draw rectangles for each button */
	for(i = 0; i < NUM_BUTTONS; i++) {
		GP142_rectangleXY(BLACK,
			MENU_LEFT,
			MENU_TOP - i * BUTTON_HEIGHT,
			MENU_LEFT + BUTTON_WIDTH,
			MENU_TOP - (i + 1)*BUTTON_HEIGHT, 1);
	}
	
	/* display button text */
	i = MENU_TOP - (BUTTON_HEIGHT/2) - (font_size/2);
	GP142_printfXY(FOREST_GREEN, text_offset, i, font_size, "Go");	
	
	i -= BUTTON_HEIGHT;
	GP142_printfXY(RED, text_offset, i, font_size, "Stop");
	
	i -= BUTTON_HEIGHT;
	GP142_printfXY(BLACK, text_offset, i, font_size, "Faster");
	
	i -= BUTTON_HEIGHT;
	GP142_printfXY(BLACK, text_offset, i, font_size, "Slower");
	
	i -= BUTTON_HEIGHT;
	GP142_printfXY(BLACK, text_offset, i, font_size, "Reverse");
	
	i -= BUTTON_HEIGHT;
	GP142_printfXY(BLACK, text_offset, i, font_size, "New Color");
	i -= BUTTON_HEIGHT;
	GP142_printfXY(BLACK, text_offset, i, font_size, "Hit a key to add a car.");
	
}

/* Classify mouse click at (mouse_x,mouse_y) and return kind */
int  classify_mouse_click(int mouse_x, int mouse_y)
{
	if ((mouse_x > MENU_LEFT) &&
		(mouse_x < MENU_LEFT + BUTTON_WIDTH) &&
		(mouse_y < MENU_TOP) &&
		(mouse_y > (MENU_TOP - NUM_BUTTONS*BUTTON_HEIGHT)))
		return BUTTON_CLICK;
	else
		return OTHER_CLICK;
}



/* Process button click at location x, y.  Update car speed,	*/
/* direction, color, and whether traffic is moving as needed.	*/
void handle_button(int x, int y, int cars [MAX_VEHICLES][VEHICLES_INFO],
				   int num_of_cars)
{
	int buttonNum, j = 0;		/* number of selected button */

	/* Complain if x coordinate couldn't be inside a button */
	if (x < MENU_LEFT || x > MENU_LEFT + BUTTON_WIDTH) {
		something_is_wrong();
		return;
	}
	
	/* Convert y coordinate to button number from top. */
	buttonNum = (MENU_TOP - y)/BUTTON_HEIGHT;	 
	
	while ((j < MAX_VEHICLES) && (j <= (num_of_cars - 1)))
	{
	switch(buttonNum) {
	case 0:
		/* go */
		cars [j][MOVE] = TRUE;
		break;
	case 1:
		/* stop */
		cars [j][MOVE] = FALSE;
		break;
		
	case 2:
		/* speed up */
		cars [j][SPEED] = cars [j][SPEED] + 1;
		break;
	case 3:
		/* slow down */
		cars [j][SPEED] = cars [j][SPEED] - 1;
		if (cars [j][SPEED] < 0)
			cars [j][SPEED] = 0;
		break;
		
	case 4:
		/* reverse */ 
	cars[j][DIR] = - cars[j][DIR];

	if(cars[j][Y_POS] == HIGHWAY_CENTER +5)
		cars[j][Y_POS] = HIGHWAY_CENTER -5;
	else
	{
	if(cars[j][Y_POS] == HIGHWAY_CENTER_2 -5)
		cars[j][Y_POS] = HIGHWAY_CENTER_2 +5;
	else
	{
	if(cars[j][Y_POS] == HIGHWAY_CENTER_2 +5)
		cars[j][Y_POS] = HIGHWAY_CENTER_2 -5;
	if(cars[j][Y_POS] == HIGHWAY_CENTER -5)
		cars[j][Y_POS] = HIGHWAY_CENTER +5;
    }}
		

		break;
	case 5:
		/* change car color */
		cars [j][COLOR] = (cars [j][COLOR]+1) % MAX_COLORS;
		break;
	default:
		/*Bad news if this is ever reached! */
		something_is_wrong();
	
		break;
		
	}
	j++;
	}
}



/*****************************************************************************

     TRAFFIC AND OTHER ANIMATED OBJECTS

*****************************************************************************/


/* Update sun coordinates sun_x, sun_y by one tick */
void move_sun(int *sun_x, int *sun_y) {
	/* Move the sun to the left.  If it reaches the edge, move it */
	/* to the other side and down a bit. */
	(*sun_x) --;
	if (*sun_x < -GP142_XMAX -30) {
		*sun_x = - *sun_x;
		(*sun_y) --;
	}
}





void bird (int*bird_x, int*bird_y,int cars [MAX_VEHICLES][VEHICLES_INFO])
{
int color = BLACK; 
(*bird_x) --;
(*bird_x) --;
(*bird_x) --;
(*bird_x) --;
(*bird_x) --;

if (abs(*bird_x) > GP142_XMAX) {
	*bird_x = - *bird_x;}


if (*bird_y < HIGHWAY_CENTER || *bird_y > GP142_YMAX) {
	*bird_y = GP142_YMAX;
	
}




if (cars[0][DIR] == -1){
GP142_lineXY(color, *bird_x, *bird_y, *bird_x+ 7, *bird_y +7, FILL);
GP142_lineXY(color, *bird_x, *bird_y, *bird_x- 7, *bird_y +7, FILL);

(*bird_y) ++;


}

if (cars[0][DIR] == 1){
GP142_lineXY(color, *bird_x, *bird_y, *bird_x+ 7, *bird_y -7, FILL);
GP142_lineXY(color, *bird_x, *bird_y, *bird_x- 7, *bird_y -7, FILL);
(*bird_x) ++;
(*bird_x) ++;
(*bird_x) ++;
(*bird_x) ++;
(*bird_x) ++;
(*bird_y) --;


}
}


/* Update all vehicle x, y coordinates, given current x, y */
/* location, direction (+1 or -1), and speed in pixels per tick, */
void move_traffic(int cars [MAX_VEHICLES][VEHICLES_INFO], int num_of_cars) {


	int trial_x;		/* new value for x coordinate */
	int j = 0;

	while ((j < MAX_VEHICLES) && (j <= (num_of_cars - 1)) )
	{
	/* move vehicle.  If it moves off the edge, reverse direction */
	trial_x = cars[j][X_POS] + (cars[j][DIR] * cars[j][SPEED]);
	if (abs(trial_x) > GP142_XMAX + CAR_WIDTH/2)
{	
	if ((trial_x > GP142_XMAX + CAR_WIDTH/2) && 
		(cars[j][Y_POS] == (HIGHWAY_CENTER + 5)))	
	{
		cars[j][X_POS] = trial_x;
		cars[j][Y_POS] = HIGHWAY_CENTER_2 -5;
		cars[j][DIR]   = - cars[j][DIR];
	}
	if ((trial_x < -GP142_XMAX - CAR_WIDTH/2) && 
		(cars[j][Y_POS] == (HIGHWAY_CENTER_2 - 5)))	
	{
		cars[j][X_POS] = trial_x;
		cars[j][Y_POS] = HIGHWAY_CENTER + 5;
		cars[j][DIR]   = - cars[j][DIR];
	}
	if ((trial_x < -GP142_XMAX - CAR_WIDTH/2) && 
		(cars[j][Y_POS] == (HIGHWAY_CENTER - 5)))	
	{
		cars[j][X_POS] = trial_x;
		cars[j][Y_POS] = HIGHWAY_CENTER_2 + 5;
		cars[j][DIR]   = - cars[j][DIR];
	}
	if ((trial_x > GP142_XMAX + CAR_WIDTH/2) && 
		(cars[j][Y_POS] == (HIGHWAY_CENTER_2 + 5)))	
	{
		cars[j][X_POS] = trial_x;
		cars[j][Y_POS] = HIGHWAY_CENTER - 5;
		cars[j][DIR]   = - cars[j][DIR];
	}

}
	else
		cars[j][X_POS] = trial_x;
	j++;
	}
}


/* Draw all vehicles given their current x, y coordinates and color */
void draw_traffic(int cars [MAX_VEHICLES][VEHICLES_INFO], int num_of_cars) {
	
	
	int j = 0;

	while ( (j <= (num_of_cars - 1)) && (j < MAX_VEHICLES))
	{
		
	draw_car(cars [j][X_POS],cars [j][Y_POS],cars [j][COLOR], j, cars [j][DIR]);
	
	
	j++;
	}
}



/* Draw a single car of the given color with horizontal */
/* center x and bottom y*/
void draw_car(int x, int y, int color, int j, int dir) {

	int font_size = 16;

   	
	
	if(((j%3) != 0) && ((j%2) == 0) && ((j%4) != 0))
	{
	GP142_rectangleXY(YELLOW, x - CAR_WIDTH*3/2, y + CAR_HEIGHT/4,
						x + CAR_WIDTH*3/2, y + CAR_HEIGHT*5/3, FILL);
	
	if (dir == 1)
{
	
	/*BUS*/

	/*windows*/
	GP142_rectangleXY(BLACK, x + CAR_WIDTH+5, y + CAR_HEIGHT,
						x + CAR_WIDTH*3/2-1, y + CAR_HEIGHT*5/3-1, FILL);
	GP142_rectangleXY(BLACK, x - CAR_WIDTH+60, y + CAR_HEIGHT,
						x - CAR_WIDTH+34, y + CAR_HEIGHT*5/3-1, FILL);
	GP142_rectangleXY(BLACK, x - CAR_WIDTH+30, y + CAR_HEIGHT,
						x - CAR_WIDTH*3/2+25, y + CAR_HEIGHT*5/3-1, FILL);
	GP142_rectangleXY(BLACK, x - CAR_WIDTH*3/2+21, y + CAR_HEIGHT,
						x - CAR_WIDTH*3/2+1, y + CAR_HEIGHT*5/3-1, FILL);


	/*wheels*/
	GP142_circleXY(BLACK, x - CAR_WIDTH-8, y + CAR_HEIGHT/4, CAR_HEIGHT/4);
	GP142_circleXY(BLACK, x - CAR_WIDTH+10, y + CAR_HEIGHT/4, CAR_HEIGHT/4);
	GP142_circleXY(BLACK, x + CAR_WIDTH+8, y + CAR_HEIGHT/4, CAR_HEIGHT/4);
	
	
	
	/*door*/
	GP142_lineXY(BLACK, x + CAR_WIDTH-3, y + CAR_HEIGHT/4+2,x + CAR_WIDTH-3,
					y + CAR_HEIGHT*4/3, FILL);
	GP142_lineXY(BLACK, x + CAR_WIDTH-7, y + CAR_HEIGHT/4+2,x + CAR_WIDTH-7,
					y + CAR_HEIGHT*4/3, FILL);
	GP142_lineXY(BLACK, x + CAR_WIDTH-11, y + CAR_HEIGHT/4+2,x + CAR_WIDTH-11,
					y + CAR_HEIGHT*4/3, FILL);
	GP142_lineXY(BLACK, x + CAR_WIDTH-11, y + CAR_HEIGHT*4/3,x + CAR_WIDTH-3,
					y + CAR_HEIGHT*4/3, FILL);
	GP142_lineXY(BLACK, x + CAR_WIDTH-11, y + CAR_HEIGHT/4+2,x + CAR_WIDTH-3,
					y + CAR_HEIGHT/4+2, FILL);
	
}
else
{
	/*windows*/
	GP142_rectangleXY(BLACK, x - CAR_WIDTH-5, y + CAR_HEIGHT,
						x - CAR_WIDTH*3/2+1, y + CAR_HEIGHT*5/3-1, FILL);
	GP142_rectangleXY(BLACK, x + CAR_WIDTH-60, y + CAR_HEIGHT,
						x + CAR_WIDTH-34, y + CAR_HEIGHT*5/3-1, FILL);
	GP142_rectangleXY(BLACK, x + CAR_WIDTH-30, y + CAR_HEIGHT,
						x + CAR_WIDTH*3/2-25, y + CAR_HEIGHT*5/3-1, FILL);
	GP142_rectangleXY(BLACK, x + CAR_WIDTH*3/2-21, y + CAR_HEIGHT,
						x + CAR_WIDTH*3/2-1, y + CAR_HEIGHT*5/3-1, FILL);


	/*wheels*/
	GP142_circleXY(BLACK, x + CAR_WIDTH+8, y + CAR_HEIGHT/4, CAR_HEIGHT/4);
	GP142_circleXY(BLACK, x + CAR_WIDTH-10, y + CAR_HEIGHT/4, CAR_HEIGHT/4);
	GP142_circleXY(BLACK, x - CAR_WIDTH-8, y + CAR_HEIGHT/4, CAR_HEIGHT/4);
	
	
	
	/*door*/
	GP142_lineXY(BLACK, x - CAR_WIDTH+3, y + CAR_HEIGHT/4+2,x - CAR_WIDTH+3,
					y + CAR_HEIGHT*4/3, FILL);
	GP142_lineXY(BLACK, x - CAR_WIDTH+7, y + CAR_HEIGHT/4+2,x - CAR_WIDTH+7,
					y + CAR_HEIGHT*4/3, FILL);
	GP142_lineXY(BLACK, x - CAR_WIDTH+11, y + CAR_HEIGHT/4+2,x - CAR_WIDTH+11,
					y + CAR_HEIGHT*4/3, FILL);
	GP142_lineXY(BLACK, x - CAR_WIDTH+11, y + CAR_HEIGHT*4/3,x - CAR_WIDTH+3,
					y + CAR_HEIGHT*4/3, FILL);
	GP142_lineXY(BLACK, x - CAR_WIDTH+11, y + CAR_HEIGHT/4+2,x - CAR_WIDTH+3,
					y + CAR_HEIGHT/4+2, FILL);

}
	}
	
else
	{
		
	if (((j%3) != 0) && ((j%4) == 0))
	{

	if (dir == 1)
{
	/*MAC*/

	/*body*/
	GP142_rectangleXY(color+2, x - CAR_WIDTH*3/2, y + CAR_HEIGHT/4,
						x + CAR_WIDTH*1/2, y + CAR_HEIGHT*5/3, FILL);
	GP142_rectangleXY(BLACK, x + CAR_WIDTH*1/2, y + CAR_HEIGHT/4,
						x + CAR_WIDTH*1/2+15, y + CAR_HEIGHT/4+10, FILL);
	GP142_rectangleXY(BLACK, x + CAR_WIDTH*1/2+15, y + CAR_HEIGHT/4,
						x + CAR_WIDTH*3/2, y + CAR_HEIGHT*5/3, FILL);
	GP142_rectangleXY(color,x - CAR_WIDTH*3/2, y + CAR_HEIGHT*2/3+4,
						x + CAR_WIDTH*1/2, y + CAR_HEIGHT*4/3+4, FILL);
	GP142_rectangleXY(RED, x + CAR_WIDTH*3/2-16, y + CAR_HEIGHT*5/3-11,
						x + CAR_WIDTH*3/2-1, y + CAR_HEIGHT*5/3-1, FILL);
	GP142_printfXY(color+3, x- CAR_WIDTH*3/2+20, y+20 , font_size, "Beal");
   

	/*wheels*/
	GP142_circleXY(BLACK, x - CAR_WIDTH-8, y + CAR_HEIGHT/4, CAR_HEIGHT/4);
	GP142_circleXY(BLACK, x - CAR_WIDTH+10, y + CAR_HEIGHT/4, CAR_HEIGHT/4);
	GP142_circleXY(color+4, x + CAR_WIDTH+8, y + CAR_HEIGHT/4, CAR_HEIGHT/4);
	
	
	
	
}
	else
{

	/*body*/
	GP142_rectangleXY(color+2, x + CAR_WIDTH*3/2, y + CAR_HEIGHT/4,
						x - CAR_WIDTH*1/2, y + CAR_HEIGHT*5/3, FILL);
	GP142_rectangleXY(BLACK, x - CAR_WIDTH*1/2, y + CAR_HEIGHT/4,
						x - CAR_WIDTH*1/2-15, y + CAR_HEIGHT/4+10, FILL);
	GP142_rectangleXY(BLACK, x - CAR_WIDTH*1/2-15, y + CAR_HEIGHT/4,
						x - CAR_WIDTH*3/2, y + CAR_HEIGHT*5/3, FILL);
	GP142_rectangleXY(color,x + CAR_WIDTH*3/2, y + CAR_HEIGHT*2/3+4,
						x - CAR_WIDTH*1/2, y + CAR_HEIGHT*4/3+4, FILL);
	GP142_rectangleXY(RED, x - CAR_WIDTH*3/2+16, y + CAR_HEIGHT*5/3-11,
						x - CAR_WIDTH*3/2+1, y + CAR_HEIGHT*5/3-1, FILL);
	GP142_printfXY(color+3, x+ CAR_WIDTH*3/2-50, y+20 , font_size, "Beal");
   

	/*wheels*/
	GP142_circleXY(BLACK, x + CAR_WIDTH+8, y + CAR_HEIGHT/4, CAR_HEIGHT/4);
	GP142_circleXY(BLACK, x + CAR_WIDTH-10, y + CAR_HEIGHT/4, CAR_HEIGHT/4);
	GP142_circleXY(color+4, x - CAR_WIDTH-8, y + CAR_HEIGHT/4, CAR_HEIGHT/4);
	
	
	
}}

else
	{

	/*car*/
	
		if((j%3) == 0)
		{
		
		if(dir == 1)
		{
			/*body*/
			GP142_lineXY(color, x + CAR_WIDTH/2, y + CAR_HEIGHT*3/4,
						x + CAR_WIDTH/3- CAR_WIDTH/2+15, y + CAR_HEIGHT+10, FILL);
			GP142_rectangleXY(color, x - CAR_WIDTH/2, y + CAR_HEIGHT/4,
						x + CAR_WIDTH/2, y + CAR_HEIGHT*3/4, FILL);
			GP142_lineXY(PEACH, x, y + CAR_HEIGHT*3/4, x, 
								y + (CAR_HEIGHT*7/6), FILL);
			GP142_circleXY(BLACK, x - CAR_WIDTH/4, y + CAR_HEIGHT/4, CAR_HEIGHT/4);
			GP142_circleXY(BLACK, x + CAR_WIDTH/4, y + CAR_HEIGHT/4, CAR_HEIGHT/4);
			GP142_circleXY(PEACH, x, y + (CAR_HEIGHT*7/6) , CAR_HEIGHT/4-1);
		
		}

		else{

			/*body*/
			GP142_lineXY(color, x - CAR_WIDTH/2, y + CAR_HEIGHT*3/4,
						x - CAR_WIDTH/3+ CAR_WIDTH/2-15, y + CAR_HEIGHT+10, FILL);
			GP142_rectangleXY(color, x + CAR_WIDTH/2, y + CAR_HEIGHT/4,
						x - CAR_WIDTH/2, y + CAR_HEIGHT*3/4, FILL);
			GP142_lineXY(PEACH, x, y + CAR_HEIGHT*3/4, x, 
								y + (CAR_HEIGHT*7/6), FILL);
			GP142_circleXY(BLACK, x - CAR_WIDTH/4, y + CAR_HEIGHT/4, CAR_HEIGHT/4);
			GP142_circleXY(BLACK, x + CAR_WIDTH/4, y + CAR_HEIGHT/4, CAR_HEIGHT/4);
			GP142_circleXY(PEACH, x, y + (CAR_HEIGHT*7/6) , CAR_HEIGHT/4-1);

		}}

		else
		{
		
			GP142_circleXY(BLACK, x - CAR_WIDTH/2, y + CAR_HEIGHT/4, CAR_HEIGHT/4);
			GP142_circleXY(BLACK, x + CAR_WIDTH/4, y + CAR_HEIGHT/4, CAR_HEIGHT/4);
			GP142_rectangleXY(color, x + CAR_WIDTH/4, y + CAR_HEIGHT/4,
						x - CAR_WIDTH/2, y + CAR_HEIGHT/4+5, FILL);
			if (dir == 1){
			
			
			GP142_lineXY(PEACH, x + CAR_WIDTH/4-5, y + CAR_HEIGHT/4+6, 
							x-5, y + CAR_HEIGHT*7/6-3 , FILL);
			GP142_lineXY(color,  x + CAR_WIDTH/4-5, y + CAR_HEIGHT/4+6, 
							x , y + CAR_HEIGHT*7/6-7, FILL);
			}
			else{


			
			GP142_lineXY(PEACH, x - CAR_WIDTH/4+5,  y + CAR_HEIGHT*7/6-3 , 
							x - CAR_WIDTH/2,y + CAR_HEIGHT/4+6, FILL);
			GP142_lineXY(color,  x - CAR_WIDTH/4,y + CAR_HEIGHT*7/6-9, 
							x - CAR_WIDTH/2,  y + CAR_HEIGHT/4+6, FILL);

			}

			GP142_circleXY(PEACH, x-5, y + (CAR_HEIGHT*7/6) , CAR_HEIGHT/4-1);
			GP142_lineXY(PEACH, x-5,y + CAR_HEIGHT/4-3, x-5, y + CAR_HEIGHT*7/6 , FILL);
			
		}
		
}		
}
}
/* Draw a man by the road */

void man (int cars [MAX_VEHICLES][VEHICLES_INFO], int num_of_cars)
{
	int j = 0;
	

	/*Head*/
	GP142_circleXY(BLACK, (MAN_DIS+1), (HIGHWAY_CENTER+40+HEAD), HEAD);
	
	/*eyes*/
	GP142_circleXY(RED, (MAN_DIS), (HIGHWAY_CENTER+40+HEAD)+(HEAD/2), HEAD/4);
	GP142_circleXY(RED, (MAN_DIS+2), (HIGHWAY_CENTER+40+HEAD)+(HEAD/2), HEAD/4);

	/*Mouth*/
	GP142_lineXY(RED, (MAN_DIS-1), (HIGHWAY_CENTER+40+HEAD)-(HEAD/2), (MAN_DIS+4),
					(HIGHWAY_CENTER+40+HEAD)-(HEAD/2), FILL);
	/*Body*/
	GP142_rectangleXY(BLACK, MAN_DIS, (HIGHWAY_CENTER+40),
						(MAN_DIS+2), (HIGHWAY_CENTER+25), FILL);
	
	/*Legs*/
	GP142_lineXY(BLACK, (MAN_DIS+3), (HIGHWAY_CENTER+26), (MAN_DIS+4),
					(HIGHWAY_CENTER+15), FILL);
	GP142_lineXY(BLACK, (MAN_DIS-1), (HIGHWAY_CENTER+26), (MAN_DIS-2),
					(HIGHWAY_CENTER+15), FILL);
	GP142_rectangleXY(BLACK, (MAN_DIS+4), (HIGHWAY_CENTER+15),
						(MAN_DIS+6), (HIGHWAY_CENTER+14), FILL);
	GP142_rectangleXY(BLACK, (MAN_DIS-2), (HIGHWAY_CENTER+15),
						(MAN_DIS-4), (HIGHWAY_CENTER+14), FILL);
	/*Arms*/

	GP142_rectangleXY(BLACK, (MAN_DIS-4), (HIGHWAY_CENTER+30),
						(MAN_DIS-6), (HIGHWAY_CENTER+28), FILL);
	GP142_lineXY(BLACK, (MAN_DIS-1), (HIGHWAY_CENTER+38), (MAN_DIS-4),
					(HIGHWAY_CENTER+30), FILL);
	
	GP142_lineXY(BLACK, (MAN_DIS+3), (HIGHWAY_CENTER+38), (MAN_DIS+6),
					(HIGHWAY_CENTER+30), FILL);
	GP142_rectangleXY(BLACK, (MAN_DIS+6), (HIGHWAY_CENTER+30),
						(MAN_DIS+8), (HIGHWAY_CENTER+28), FILL);
	
	while ((j < MAX_VEHICLES) && (j < (num_of_cars)) )
	{
	if((cars [j][X_POS] > (MAN_DIS-200))&&(cars[j][X_POS] < (MAN_DIS+50)))
{
	if (cars[j][Y_POS] == (HIGHWAY_CENTER +5))
	{
	
	GP142_lineXY(BROWN, (MAN_DIS+3), (HIGHWAY_CENTER+38), (MAN_DIS+6),
					(HIGHWAY_CENTER+30), FILL);
	GP142_rectangleXY(BROWN, (MAN_DIS+6), (HIGHWAY_CENTER+30),
						(MAN_DIS+8), (HIGHWAY_CENTER+28), FILL);	
	GP142_lineXY(BLACK, (MAN_DIS+3), (HIGHWAY_CENTER+38), (MAN_DIS+10),
					(HIGHWAY_CENTER+42), FILL);
	GP142_rectangleXY(BLACK, (MAN_DIS+10), (HIGHWAY_CENTER+42),
						(MAN_DIS+12), (HIGHWAY_CENTER+44), FILL);
	GP142_lineXY(BLACK, (MAN_DIS+10), (HIGHWAY_CENTER+43), (MAN_DIS+10),
					(HIGHWAY_CENTER+47), FILL);

	
	}
}
	
	
j++;

}
	/*Bags*/
	GP142_rectangleXY(ORANGE, (MAN_DIS-8), (HIGHWAY_CENTER+26),
						(MAN_DIS-12), (HIGHWAY_CENTER+14), FILL);
	GP142_rectangleXY(RED, (MAN_DIS-13), (HIGHWAY_CENTER+20),
						(MAN_DIS-16), (HIGHWAY_CENTER+14), FILL);
}



/*****************************************************************************

     OTHER

*****************************************************************************/


/* Initialize random number generator */
/* [Ignore or delete if your program  */
/* doesn't user random numbers.] */
void initialize_random_numbers() {
	time_t t;			/* current time */
	srand (time(&t));
}



/* Display error message if internal error is detected. */
void something_is_wrong (void) {
	GP142_printfXY (RED, 0, 0, 16, "BAAAADDD NEWS!");
}